# Generated by go2rpm 1
%bcond_without check
%global debug_package %{nil}

# https://qpid.apache.org
%global goipath         qpid.apache.org
%global goghipath       github.com/apache/qpid-proton
%global tag             0.32.0-rc1

%ifarch x86_64 amd64
%global archdir         linux_amd64
%endif
%ifarch ppc64le
%global archdir         linux_ppc64le
%endif
%ifarch aarch64
%global archdir         linux_arm64
%endif

%global godocs          readme-go-get.md README.md

Name:           golang-qpid-apache
Version:        0.32.0
Release:        rc1.7%{?dist}
Summary:        Golang binding library for qpid-proton
License:        BSD and ASL 2.0
URL:            https://gitbox.apache.org/repos/asf/qpid-proton.git/

# Thanks to non-traditional repo the source had to be creted manually.
# Use following tool to get the source: "get_source.sh <version>"
Source0:        golang-qpid-apache-0.32.0-rc1.tar.gz

BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires:  qpid-proton-c-devel

Requires:       qpid-proton-c-devel
Provides:       golang(%{goipath}) = %{version}-%{release}
Provides:       golang(%{goipath}/electron) = %{version}-%{release}
Provides:       golang(%{goipath}/proton) = %{version}-%{release}
Provides:       golang(%{goipath}/amqp) = %{version}-%{release}


%description
Apache Qpid™ makes messaging tools that speak AMQP and support many languages and platforms.


%prep
%autosetup -n %{goipath}


%build
grep -rl "%{goghipath}/go/pkg" . | xargs sed -i 's#%{goghipath}/go/pkg#%{goipath}#g'
grep -rl "%{goghipath}" . | xargs sed -i 's#%{goghipath}#%{goipath}#g'

pushd ./go/pkg
go mod init %{goipath}
mkdir -p $(dirname ./build/src/%{goipath})
ln -s $PWD ./build/src/%{goipath}

# create binary packages
export GOPATH=$PWD/build
for pkg in amqp electron proton; do
  pushd ./build/src/%{goipath}/$pkg
  go install .
  popd
done
popd


%install
pushd ./go/pkg
# copy binary packages
install -d -p %{buildroot}/%{gopath}/pkg/%{archdir}/%{goipath}/
pushd ./build/pkg/%{archdir}/%{goipath}/
for file in $(find . -iname "*.a") ; do
    cp -pav $file %{buildroot}/%{gopath}/pkg/%{archdir}/%{goipath}/$file
done
popd
rm -fr ./build ./internal
# copy packages source
install -d -p %{buildroot}/%{gopath}/src/%{goipath}/
for file in ./* ; do
    if [ -d $file ]; then
        cp -rpav $file %{buildroot}%{gopath}/src/%{goipath}/
    fi
done
popd


%files
%{gopath}/src/%{goipath}
%{gopath}/pkg/%{archdir}/%{goipath}


%changelog
* Wed Sep 02 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.7
- Cleanup
- Fixed invalid import paths

* Tue Sep 01 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.6
- Provide also go module

* Tue Sep 01 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.5
- Provide source files also on github path
- Fix require for qpid-proton-c

* Tue Sep 01 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.3
- Provide also binary packages

* Mon Aug 24 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.1
- Initial package
